#include "myTim.h"
#include "stm32f10x_tim.h"
#include "stm32f10x_it.h" 

TIM_CALLBACK timCallBack;

static irqCallback_ts myIrqCallback_tim1;
static irqCallback_ts myIrqCallback_tim3;

/**
 * @brief tim3жϺ
 *  ͨAPI@TIM3_callbackRegisteעᵽ@stm32f10x_it.cежϺ
 * 
 * @param status 
 * @param param 
 */
void tim3_callback(uint8_t status, uint32_t param)   //TIM3ж
{
    if(timCallBack)
    {
        timCallBack();
    }
}
/**
 * tim3ʱʼ
 * @period_usʱʱڣ΢Ϊλ
 * @cbʱصʱʱʱøú
        ൱׳жϣ
*/
void myTim3_init(uint32_t period_us, TIM_CALLBACK cb)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    myIrqCallback_tim3.thisCb = tim3_callback;
    TIM3_callbackRegiste(&myIrqCallback_tim3);       

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE); //ʱʹ
    //жȼNVIC
    NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;  //TIM3ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;  //ȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);  //ʼNVICĴ
        
    //ʱTIM3ʼ
    TIM_TimeBaseStructure.TIM_Period = period_us; //һ¼װԶװؼĴڵֵ  
    TIM_TimeBaseStructure.TIM_Prescaler = (72 - 1); //ϵͳʱ72MHzTIM_ClockDivision = TIM_CKD_DIV1
                                                    //˴72Ƶõ1MHzļʱӣ1MHz = 1usڣ
                                                    //Ҫ΢ڣֻͨTIM_PeriodֵȿɵõӦ
                                                    //ڶʱ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; //ʱӷָ:TDTS = Tck_tim
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //TIMϼģʽ
    TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ
 
    TIM_ITConfig(TIM3,TIM_IT_Update,ENABLE ); //ʹָTIM3ж,ж

    TIM_Cmd(TIM3, ENABLE);  //ʹTIMx 
    timCallBack = cb;    

}
/**
 * @brief tim1жϺ
 *  ͨAPI@TIM1_callbackRegisteעᵽ@stm32f10x_it.cежϺ
 * 
 * @param status 
 * @param param 
 */
void tim1_callback(uint8_t status, uint32_t param)   //TIM1ж
{
    if(timCallBack)
    {
        timCallBack();
    }
}
/**
 * tim1ʱʼ
 * @period_usʱʱڣ΢Ϊλ
 * @cbʱصʱʱʱøú
        ൱׳жϣ
*/
void myTim1_init(uint32_t period_us, TIM_CALLBACK cb)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    myIrqCallback_tim1.thisCb = tim1_callback;
    TIM1_callbackRegiste(&myIrqCallback_tim1);  

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE); //ʱʹ
    //жȼNVIC
    NVIC_InitStructure.NVIC_IRQChannel = TIM1_UP_IRQn;  //TIM3ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;  //ȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);  //ʼNVICĴ
        
    //ʱTIM3ʼ
    TIM_TimeBaseStructure.TIM_Period = period_us; //һ¼װԶװؼĴڵֵ  
    TIM_TimeBaseStructure.TIM_Prescaler = (72 - 1); //ϵͳʱ72MHzTIM_ClockDivision = TIM_CKD_DIV1
                                                    //˴72Ƶõ1MHzļʱӣ1MHz = 1usڣ
                                                    //Ҫ΢ڣֻͨTIM_PeriodֵȿɵõӦ
                                                    //ڶʱ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; //ʱӷָ:TDTS = Tck_tim
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //TIMϼģʽ
    TIM_TimeBaseInit(TIM1, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ
 
    TIM_ITConfig(TIM1, TIM_IT_Update, ENABLE ); //ʹָTIM3ж,ж

    TIM_Cmd(TIM1, ENABLE);  //ʹTIMx    
    timCallBack = cb;    

}

