#include "myUart3.h"
#include "stm32f10x.h"
#include "stm32f10x_usart.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_it.h" 
#include "misc.h"
#include <stdarg.h>
#include <string.h>

static uint16_t USART_RX_STA;       //״̬    
static UART_CALLBACK uartRxCallBack;
static uint8_t USART3_RX_BUF[USART_REC_LEN];
static irqCallback_ts myIrqCallback_uart3;

/**
 * @brief uart3жϺ
 *  ͨAPI@USART1_callbackRegisteעᵽ@stm32f10x_it.cежϺ
 * 
 * @param status ڽ״̬
 *                  =0ճʱ
 *                  =1յһֽ
 * @param param 
 */
void uart3_callback(uint8_t status, uint32_t param)
{
    uint8_t Res;

    switch (status)
    {
    case 0:
    {
        uartRxCallBack(USART3_RX_BUF, USART_RX_STA);
        memset(USART3_RX_BUF, 0, sizeof(USART3_RX_BUF));
        USART_RX_STA=0;
    }
        break;
    case 1:
    {
        //ȡյ
        USART3_RX_BUF[USART_RX_STA] = param;
        USART_RX_STA++;
        if(USART_RX_STA > (USART_REC_LEN - 1))
        {
            USART_RX_STA=0;//ݴ,¿ʼ    
        }
    }
        break;
    
    default:
        break;
    }
}

void myUart3_init(uint32_t baudrate, UART_CALLBACK cb)
{
    //GPIO˿
    GPIO_InitTypeDef GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    myIrqCallback_uart3.thisCb = uart3_callback;
    USART1_callbackRegiste(&myIrqCallback_uart3);  

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);  
    //USART3_TX
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10; //
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; //
    GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼ

    //USART3_RXʼ
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;//
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;//
    GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼ

    //Usart3 NVIC 
    NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=3 ;//ռȼ3
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;      //ȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;         //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure); //ָĲʼVICĴ

    //USART ʼ

    USART_InitStructure.USART_BaudRate = baudrate;//ڲ
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;//ֳΪ8λݸʽ
    USART_InitStructure.USART_StopBits = USART_StopBits_1;//һֹͣλ
    USART_InitStructure.USART_Parity = USART_Parity_No;//żУλ
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;//Ӳ
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; //շģʽ

    USART_Init(USART3, &USART_InitStructure); //ʼ
    USART_ITConfig(USART3, USART_IT_RXNE, ENABLE);//ڽж
    USART_ITConfig(USART3, USART_IT_IDLE, ENABLE);//ڽж
    // USART_ITConfig(USART3, USART_IT_TC, ENABLE);// ʹܴڷж
    uartRxCallBack = cb;
    USART_Cmd(USART3, ENABLE);                    //ʹܴ

}

static void myUart3_sendByte(uint8_t sendByte)
{
    while(!USART_GetFlagStatus(USART3, USART_FLAG_TC))
    {
        ;
    }
    USART_SendData(USART3, sendByte);
}
static void myUart3_sendArray(uint8_t *buffer, uint16_t sendLen)
{
	int i = 0;
    for (i = 0; i < sendLen; i++)
    {
        myUart3_sendByte(*buffer);
        buffer ++;
    }
    
}
void myUart3_printf(uint16_t sendLen, char *fmt, ...)
{
    va_list va;
    char tempTab[256];
    int len;
    if (sendLen)
    {
        myUart3_sendArray((uint8_t *)fmt, sendLen);
    }
    else
    {
        va_start(va, fmt);
        memset(tempTab, 0, sizeof(tempTab));
        vsnprintf(tempTab, (int)sizeof(tempTab), fmt, va);
        len = strlen(tempTab);
        myUart3_sendArray((uint8_t *)tempTab, len);
        va_end(va);
    }
}

