#ifndef __MY_RADIO_H
#define __MY_RADIO_H
/* Includes ------------------------------------------------------------------*/
#include <stdio.h>
#include <stdbool.h>
#include <stdint.h>
#include <string.h>

#define MAX_RF_PACKET_LEN 128
/*!
 * Select mode of operation for the Ping Ping application
 */
#ifndef MODE_BLE || MODE_LORA || MODE_GFSK || MODE_FLRC
//#define MODE_BLE
// #define MODE_LORA
// #define MODE_GFSK
#define MODE_FLRC
#endif
typedef enum
{
    RF_BAUDRATE_GF_0_125M, 
    RF_BAUDRATE_GF_0_250M, 
    RF_BAUDRATE_GF_0_250M_, 
    RF_BAUDRATE_GF_0_400M, 
    RF_BAUDRATE_GF_0_400M_, 
    RF_BAUDRATE_GF_0_500M, 
    RF_BAUDRATE_GF_0_500M_, 
    RF_BAUDRATE_GF_0_800M, 
    RF_BAUDRATE_GF_0_800M_, 
    RF_BAUDRATE_GF_1_000M, 
    RF_BAUDRATE_GF_1_000M_, 
    RF_BAUDRATE_GF_1_600M, 
    RF_BAUDRATE_GF_2_000M,
    MAX_RF_BAUDRATE_GF_COUNT,    //
}rfBaudrate_gf_te;
typedef enum
{
    RF_BAUDRATE_LR_216B, 
    RF_BAUDRATE_LR_001K, 
    RF_BAUDRATE_LR_005K, 
    RF_BAUDRATE_LR_010K, 
    RF_BAUDRATE_LR_020K, 
    RF_BAUDRATE_LR_061K, 
    RF_BAUDRATE_LR_127K, 
    RF_BAUDRATE_LR_203K, 
    MAX_RF_BAUDRATE_LR_COUNT,    //
}rfBaudrate_lora_te;
typedef enum
{
    RF_BAUDRATE_FLR_0_13M,
    RF_BAUDRATE_FLR_0_26M,
    RF_BAUDRATE_FLR_0_52M,
    RF_BAUDRATE_FLR_1_04M,
    MAX_RF_BAUDRATE_FLR_COUNT,    //
}rfBaudrate_fastLora_te;

typedef enum
{
    RF_TX_PWR_N_18,
    RF_TX_PWR_N_17,
    RF_TX_PWR_N_16,
    RF_TX_PWR_N_15,
    RF_TX_PWR_N_14,
    RF_TX_PWR_N_13,
    RF_TX_PWR_N_12,
    RF_TX_PWR_N_11,
    RF_TX_PWR_N_10,
    RF_TX_PWR_N_9,
    RF_TX_PWR_N_8,
    RF_TX_PWR_N_7,
    RF_TX_PWR_N_6,
    RF_TX_PWR_N_5,
    RF_TX_PWR_N_4,
    RF_TX_PWR_N_3,
    RF_TX_PWR_N_2,
    RF_TX_PWR_N_1,
    RF_TX_PWR_N_0,
    RF_TX_PWR_P_1,
    RF_TX_PWR_P_2,
    RF_TX_PWR_P_3,
    RF_TX_PWR_P_4,
    RF_TX_PWR_P_5,
    RF_TX_PWR_P_6,
    RF_TX_PWR_P_7,
    RF_TX_PWR_P_8,
    RF_TX_PWR_P_9,
    RF_TX_PWR_P_10,
    RF_TX_PWR_P_11,
    RF_TX_PWR_P_12,
    RF_TX_PWR_P_13,
    RF_TX_PWR_MAX_COUNT,
}rf_txPwr_te;
typedef enum
{
    DVTP_VG2391S240N0M1,
    DVTP_VG2392S240N0M1,
    DVTP_VG2392S240X0M1,
    DVTP_VG2392S240X0M2,
#ifdef MODULE_IS_1W
    DVTP_VG2392S240X0M3,
#endif
    DVTP_MAX_COUNT,
}deviceType_te;

typedef enum
{
    FREQ_BAND_315,
    FREQ_BAND_433,
    FREQ_BAND_490,
    FREQ_BAND_868,
    FREQ_BAND_915,
    MAX_FREQ_BAND_COUNT,
}freqBand_te;

typedef enum
{
    RF_MM_MODE_BLE,
    RF_MM_MODE_LORA,
    RF_MM_MODE_GFSK,
    RF_MM_MODE_FLRC,
    MAX_RF_MM_MODE_COUNT,
}rfModuleMode_te;
//! \brief Structure for the TX Packet
typedef struct
{
    uint8_t rmvAddr[8];              //
    uint32_t absTime;                //
    uint8_t len;                     //
    uint8_t payload[MAX_RF_PACKET_LEN];       //
} rfTxPacket_ts;

typedef struct
{
    uint8_t rmvAddr[8];              //
    int16_t rssi;                     //
    uint32_t absTime;                //
    uint32_t rxTimeout;              //
    uint8_t len;                     //
    uint8_t payload[MAX_RF_PACKET_LEN];
} rfRxPacket_ts;
typedef struct
{
    uint8_t SignalBw;                   // LORA_BW_0200, LORA_BW_0400, LORA_BW_0800, LORA_BW_1600, 
    uint8_t SpreadingFactor;            //  LORA_SF5~LORA_SF12
    uint8_t ErrorCoding;                // 1-LORA_CR_4_5, 2-LORA_CR_4_6, 3-LORA_CR_4_7 , 4-LORA_CR_4_8 , 5-LORA_CR_LI_4_5, 6-LORA_CR_LI_4_6, 7-LORA_CR_LI_4_7,
}loraBaudrateFrame_ts;
typedef struct
{
    uint8_t BitrateBandwidth;  //@RadioFlrcBitrates_t          !< FLRC ƵĴͱֵ
    uint8_t CodingRate;        //@RadioFlrcCodingRates_t       !< FLRCƵı
    uint8_t ModulationShaping; //@RadioModShapings_t           !< FLRCƵĵ
}fastloraBaudrateFrame_ts;

typedef enum 
{
    RADIO_EXT_CONTROL_TX_UNMODULATED,   //زʲ
    RADIO_EXT_CONTROL_RX_SENSITIVITY,   //Ȳ
    RADIO_EXT_CONTROL_TX_MODULATED,   //Ʋ
}controlMode_te;
typedef enum
{
    RX_STA_SECCESS,
    RX_STA_TIMEOUT,
    RX_STA_PAYLOAD_ERROR,
    TX_STA_SECCESS,
    TX_STA_ERROR,
}rxStatus_te;
typedef void (*rfRxCallBack)(uint8_t status, rfRxPacket_ts packet);
void myRadio_setRfModuleMode(uint8_t mode);
void myRadio_init(int agr0, void *agr1_ptr);
void myRadio_abort(void);
uint32_t myRadio_getFrequency(void);
void myRadio_setFrequency(uint32_t freq);
int8_t myRadio_getTxPower(void);
void myRadio_setTxPower(int8_t power);
uint32_t myRadio_getBaudrate(void);
void myRadio_setBaudrate(uint32_t br);
void myRadio_setChipType(uint8_t type);
uint8_t myRadio_getChipType(void);
int16_t myRadio_getRssi(void);
void myRadio_transmit(rfTxPacket_ts *packet);
void myRadio_receiver(void);
void myRadio_setCtrl(controlMode_te mode, uint32_t value);

#endif

